/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with sieve_yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum sieve_yytokentype {
     IDENT = 258,
     TAG = 259,
     NUMBER = 260,
     STRING = 261,
     MULTILINE = 262,
     REQUIRE = 263,
     IF = 264,
     ELSIF = 265,
     ELSE = 266,
     ANYOF = 267,
     ALLOF = 268,
     NOT = 269
   };
#endif
#define IDENT 258
#define TAG 259
#define NUMBER 260
#define STRING 261
#define MULTILINE 262
#define REQUIRE 263
#define IF 264
#define ELSIF 265
#define ELSE 266
#define ANYOF 267
#define ALLOF 268
#define NOT 269




/* Copy the first part of user declarations.  */
#line 1 "sieve.y"

/* GNU Mailutils -- a suite of utilities for electronic mail
   Copyright (C) 1999, 2000, 2001, 2002 Free Software Foundation, Inc.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General
   Public License along with this library; if not, write to the
   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301 USA */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif  
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <sieve.h>

sieve_machine_t sieve_machine;
int sieve_error_count;

static void branch_fixup __P((size_t start, size_t end));
int sieve_yyerror (char *s);
int sieve_yylex (); 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 36 "sieve.y"
typedef union YYSTYPE {
  char *string;
  size_t number;
  sieve_instr_t instr;
  sieve_value_t *value;
  list_t list;
  size_t pc;
  struct {
    size_t start;
    size_t end;
  } pclist;
  struct {
    char *ident;
    list_t args;
  } command;
  struct {
    size_t begin;
    size_t cond;
    size_t branch;
  } branch;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 160 "y.tab.c"
# define sieve_yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 172 "y.tab.c"

#if ! defined (sieve_yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (sieve_yyoverflow) || YYERROR_VERBOSE */


#if (! defined (sieve_yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union sieve_yyalloc
{
  short sieve_yyss;
  YYSTYPE sieve_yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union sieve_yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T sieve_yyi;		\
	  for (sieve_yyi = 0; sieve_yyi < (Count); sieve_yyi++)	\
	    (To)[sieve_yyi] = (From)[sieve_yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T sieve_yynewbytes;						\
	YYCOPY (&sieve_yyptr->Stack, Stack, sieve_yysize);				\
	Stack = &sieve_yyptr->Stack;						\
	sieve_yynewbytes = sieve_yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	sieve_yyptr += sieve_yynewbytes / sizeof (*sieve_yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char sieve_yysigned_char;
#else
   typedef short sieve_yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  22
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   54

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  23
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  24
/* YYNRULES -- Number of rules. */
#define YYNRULES  43
/* YYNRULES -- Number of states. */
#define YYNSTATES  68

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   269

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? sieve_yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char sieve_yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      19,    20,     2,     2,    18,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    15,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    21,     2,    22,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    16,     2,    17,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char sieve_yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    15,    18,    23,
      25,    27,    31,    32,    34,    39,    45,    47,    49,    53,
      55,    59,    61,    63,    68,    73,    76,    77,    79,    82,
      84,    85,    87,    89,    92,    94,    96,    98,   100,   102,
     104,   106,   110,   112
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const sieve_yysigned_char sieve_yyrhs[] =
{
      24,     0,    -1,    -1,    25,    -1,    26,    -1,    25,    26,
      -1,     8,    44,    15,    -1,    40,    15,    -1,    27,    35,
      33,    28,    -1,     9,    -1,    29,    -1,    29,    32,    33,
      -1,    -1,    30,    -1,    31,    37,    35,    33,    -1,    30,
      31,    37,    35,    33,    -1,    10,    -1,    11,    -1,    16,
      25,    17,    -1,    36,    -1,    34,    18,    36,    -1,    36,
      -1,    38,    -1,    12,    19,    34,    20,    -1,    13,    19,
      34,    20,    -1,    14,    36,    -1,    -1,    39,    -1,     3,
      41,    -1,    39,    -1,    -1,    42,    -1,    43,    -1,    42,
      43,    -1,    45,    -1,     6,    -1,     7,    -1,     5,    -1,
       4,    -1,     6,    -1,    45,    -1,    21,    46,    22,    -1,
       6,    -1,    46,    18,     6,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short sieve_yyrline[] =
{
       0,    72,    72,    73,    77,    78,    81,    89,    91,    99,
     105,   116,   134,   137,   140,   146,   156,   164,   172,   178,
     185,   196,   204,   206,   210,   214,   222,   227,   246,   253,
     273,   276,   279,   284,   291,   295,   299,   303,   307,   313,
     318,   321,   327,   332
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const sieve_yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "TAG", "NUMBER", "STRING", 
  "MULTILINE", "REQUIRE", "IF", "ELSIF", "ELSE", "ANYOF", "ALLOF", "NOT", 
  "';'", "'{'", "'}'", "','", "'('", "')'", "'['", "']'", "$accept", 
  "input", "list", "statement", "if", "else_part", "maybe_elsif", 
  "elsif_branch", "elsif", "else", "block", "testlist", "cond", 
  "cond_expr", "begin", "test", "command", "action", "maybe_arglist", 
  "arglist", "arg", "stringorlist", "stringlist", "slist", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short sieve_yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    59,   123,   125,    44,    40,
      41,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char sieve_yyr1[] =
{
       0,    23,    24,    24,    25,    25,    26,    26,    26,    27,
      28,    28,    29,    29,    30,    30,    31,    32,    33,    34,
      34,    35,    36,    36,    36,    36,    37,    38,    39,    40,
      41,    41,    42,    42,    43,    43,    43,    43,    43,    44,
      44,    45,    46,    46
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char sieve_yyr2[] =
{
       0,     2,     0,     1,     1,     2,     3,     2,     4,     1,
       1,     3,     0,     1,     4,     5,     1,     1,     3,     1,
       3,     1,     1,     4,     4,     2,     0,     1,     2,     1,
       0,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char sieve_yydefact[] =
{
       2,    30,     0,     9,     0,     3,     4,     0,    29,     0,
      38,    37,    35,    36,     0,    28,    31,    32,    34,    39,
       0,    40,     1,     5,     0,     0,     0,     0,    21,    22,
      27,     7,    42,     0,    33,     6,     0,     0,    25,     0,
      12,     0,    41,     0,    19,     0,     0,    16,     8,    10,
      13,    26,    43,     0,    23,    24,    18,    17,     0,    26,
       0,    20,    11,     0,     0,     0,    14,    15
};

/* YYDEFGOTO[NTERM-NUM]. */
static const sieve_yysigned_char sieve_yydefgoto[] =
{
      -1,     4,     5,     6,     7,    48,    49,    50,    51,    58,
      40,    43,    27,    28,    60,    29,    30,     9,    15,    16,
      17,    20,    18,    33
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -47
static const sieve_yysigned_char sieve_yypact[] =
{
      24,     2,    -3,   -47,     4,    24,   -47,     8,   -47,    13,
     -47,   -47,   -47,   -47,    25,   -47,     2,   -47,   -47,   -47,
      26,   -47,   -47,   -47,    21,    28,     8,    27,   -47,   -47,
     -47,   -47,   -47,    12,   -47,   -47,     8,     8,   -47,    24,
      34,    39,   -47,    17,   -47,    18,     7,   -47,   -47,    37,
      34,   -47,   -47,     8,   -47,   -47,   -47,   -47,    27,   -47,
       8,   -47,   -47,     8,    27,    27,   -47,   -47
};

/* YYPGOTO[NTERM-NUM].  */
static const sieve_yysigned_char sieve_yypgoto[] =
{
     -47,   -47,    10,    -4,   -47,   -47,   -47,   -47,     1,   -47,
     -39,    15,   -46,   -24,    -9,   -47,     0,   -47,   -47,   -47,
      38,   -47,    51,   -47
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char sieve_yytable[] =
{
       8,    23,    38,    19,    22,     8,    10,    11,    12,    13,
       1,     1,    44,    44,    64,     2,     3,    65,    14,    62,
      24,    25,    26,    14,    56,    66,    67,     1,    31,    61,
      41,    32,     2,     3,    42,    53,    53,    54,    55,     8,
      36,    35,    23,    39,    47,    52,     8,    37,    57,    46,
      63,    59,    45,    21,    34
};

static const unsigned char sieve_yycheck[] =
{
       0,     5,    26,     6,     0,     5,     4,     5,     6,     7,
       3,     3,    36,    37,    60,     8,     9,    63,    21,    58,
      12,    13,    14,    21,    17,    64,    65,     3,    15,    53,
      18,     6,     8,     9,    22,    18,    18,    20,    20,    39,
      19,    15,    46,    16,    10,     6,    46,    19,    11,    39,
      59,    50,    37,     2,    16
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char sieve_yystos[] =
{
       0,     3,     8,     9,    24,    25,    26,    27,    39,    40,
       4,     5,     6,     7,    21,    41,    42,    43,    45,     6,
      44,    45,     0,    26,    12,    13,    14,    35,    36,    38,
      39,    15,     6,    46,    43,    15,    19,    19,    36,    16,
      33,    18,    22,    34,    36,    34,    25,    10,    28,    29,
      30,    31,     6,    18,    20,    20,    17,    11,    32,    31,
      37,    36,    33,    37,    35,    35,    33,    33
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define sieve_yyerrok		(sieve_yyerrstatus = 0)
#define sieve_yyclearin	(sieve_yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto sieve_yyacceptlab
#define YYABORT		goto sieve_yyabortlab
#define YYERROR		goto sieve_yyerrlab1

/* Like YYERROR except do call sieve_yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto sieve_yyerrlab

#define YYRECOVERING()  (!!sieve_yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (sieve_yychar == YYEMPTY && sieve_yylen == 1)				\
    {								\
      sieve_yychar = (Token);						\
      sieve_yylval = (Value);						\
      sieve_yytoken = YYTRANSLATE (sieve_yychar);				\
      YYPOPSTACK;						\
      goto sieve_yybackup;						\
    }								\
  else								\
    { 								\
      sieve_yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `sieve_yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX sieve_yylex (YYLEX_PARAM)
#else
# define YYLEX sieve_yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (sieve_yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (sieve_yydebug)					\
    sieve_yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (sieve_yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      sieve_yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| sieve_yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
sieve_yy_stack_print (short *bottom, short *top)
#else
static void
sieve_yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (sieve_yydebug)							\
    sieve_yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
sieve_yy_reduce_print (int sieve_yyrule)
#else
static void
sieve_yy_reduce_print (sieve_yyrule)
    int sieve_yyrule;
#endif
{
  int sieve_yyi;
  unsigned int sieve_yylineno = sieve_yyrline[sieve_yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             sieve_yyrule - 1, sieve_yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (sieve_yyi = sieve_yyprhs[sieve_yyrule]; 0 <= sieve_yyrhs[sieve_yyi]; sieve_yyi++)
    YYFPRINTF (stderr, "%s ", sieve_yytname [sieve_yyrhs[sieve_yyi]]);
  YYFPRINTF (stderr, "-> %s\n", sieve_yytname [sieve_yyr1[sieve_yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (sieve_yydebug)				\
    sieve_yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int sieve_yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef sieve_yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define sieve_yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
sieve_yystrlen (const char *sieve_yystr)
#   else
sieve_yystrlen (sieve_yystr)
     const char *sieve_yystr;
#   endif
{
  register const char *sieve_yys = sieve_yystr;

  while (*sieve_yys++ != '\0')
    continue;

  return sieve_yys - sieve_yystr - 1;
}
#  endif
# endif

# ifndef sieve_yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define sieve_yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
sieve_yystpcpy (char *sieve_yydest, const char *sieve_yysrc)
#   else
sieve_yystpcpy (sieve_yydest, sieve_yysrc)
     char *sieve_yydest;
     const char *sieve_yysrc;
#   endif
{
  register char *sieve_yyd = sieve_yydest;
  register const char *sieve_yys = sieve_yysrc;

  while ((*sieve_yyd++ = *sieve_yys++) != '\0')
    continue;

  return sieve_yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
sieve_yysymprint (FILE *sieve_yyoutput, int sieve_yytype, YYSTYPE *sieve_yyvaluep)
#else
static void
sieve_yysymprint (sieve_yyoutput, sieve_yytype, sieve_yyvaluep)
    FILE *sieve_yyoutput;
    int sieve_yytype;
    YYSTYPE *sieve_yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) sieve_yyvaluep;

  if (sieve_yytype < YYNTOKENS)
    {
      YYFPRINTF (sieve_yyoutput, "token %s (", sieve_yytname[sieve_yytype]);
# ifdef YYPRINT
      YYPRINT (sieve_yyoutput, sieve_yytoknum[sieve_yytype], *sieve_yyvaluep);
# endif
    }
  else
    YYFPRINTF (sieve_yyoutput, "nterm %s (", sieve_yytname[sieve_yytype]);

  switch (sieve_yytype)
    {
      default:
        break;
    }
  YYFPRINTF (sieve_yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
sieve_yydestruct (int sieve_yytype, YYSTYPE *sieve_yyvaluep)
#else
static void
sieve_yydestruct (sieve_yytype, sieve_yyvaluep)
    int sieve_yytype;
    YYSTYPE *sieve_yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) sieve_yyvaluep;

  switch (sieve_yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int sieve_yyparse (void *YYPARSE_PARAM);
# else
int sieve_yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int sieve_yyparse (void);
#else
int sieve_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int sieve_yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE sieve_yylval;

/* Number of syntax errors so far.  */
int sieve_yynerrs;



/*----------.
| sieve_yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int sieve_yyparse (void *YYPARSE_PARAM)
# else
int sieve_yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
sieve_yyparse (void)
#else
int
sieve_yyparse ()

#endif
#endif
{
  
  register int sieve_yystate;
  register int sieve_yyn;
  int sieve_yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int sieve_yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int sieve_yytoken = 0;

  /* Three stacks and their tools:
     `sieve_yyss': related to states,
     `sieve_yyvs': related to semantic values,
     `sieve_yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow sieve_yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	sieve_yyssa[YYINITDEPTH];
  short *sieve_yyss = sieve_yyssa;
  register short *sieve_yyssp;

  /* The semantic value stack.  */
  YYSTYPE sieve_yyvsa[YYINITDEPTH];
  YYSTYPE *sieve_yyvs = sieve_yyvsa;
  register YYSTYPE *sieve_yyvsp;



#define YYPOPSTACK   (sieve_yyvsp--, sieve_yyssp--)

  YYSIZE_T sieve_yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE sieve_yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int sieve_yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  sieve_yystate = 0;
  sieve_yyerrstatus = 0;
  sieve_yynerrs = 0;
  sieve_yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  sieve_yyssp = sieve_yyss;
  sieve_yyvsp = sieve_yyvs;

  goto sieve_yysetstate;

/*------------------------------------------------------------.
| sieve_yynewstate -- Push a new state, which is found in sieve_yystate.  |
`------------------------------------------------------------*/
 sieve_yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  sieve_yyssp++;

 sieve_yysetstate:
  *sieve_yyssp = sieve_yystate;

  if (sieve_yyss + sieve_yystacksize - 1 <= sieve_yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T sieve_yysize = sieve_yyssp - sieve_yyss + 1;

#ifdef sieve_yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *sieve_yyvs1 = sieve_yyvs;
	short *sieve_yyss1 = sieve_yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if sieve_yyoverflow is a macro.  */
	sieve_yyoverflow ("parser stack overflow",
		    &sieve_yyss1, sieve_yysize * sizeof (*sieve_yyssp),
		    &sieve_yyvs1, sieve_yysize * sizeof (*sieve_yyvsp),

		    &sieve_yystacksize);

	sieve_yyss = sieve_yyss1;
	sieve_yyvs = sieve_yyvs1;
      }
#else /* no sieve_yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto sieve_yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= sieve_yystacksize)
	goto sieve_yyoverflowlab;
      sieve_yystacksize *= 2;
      if (YYMAXDEPTH < sieve_yystacksize)
	sieve_yystacksize = YYMAXDEPTH;

      {
	short *sieve_yyss1 = sieve_yyss;
	union sieve_yyalloc *sieve_yyptr =
	  (union sieve_yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (sieve_yystacksize));
	if (! sieve_yyptr)
	  goto sieve_yyoverflowlab;
	YYSTACK_RELOCATE (sieve_yyss);
	YYSTACK_RELOCATE (sieve_yyvs);

#  undef YYSTACK_RELOCATE
	if (sieve_yyss1 != sieve_yyssa)
	  YYSTACK_FREE (sieve_yyss1);
      }
# endif
#endif /* no sieve_yyoverflow */

      sieve_yyssp = sieve_yyss + sieve_yysize - 1;
      sieve_yyvsp = sieve_yyvs + sieve_yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) sieve_yystacksize));

      if (sieve_yyss + sieve_yystacksize - 1 <= sieve_yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", sieve_yystate));

  goto sieve_yybackup;

/*-----------.
| sieve_yybackup.  |
`-----------*/
sieve_yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* sieve_yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  sieve_yyn = sieve_yypact[sieve_yystate];
  if (sieve_yyn == YYPACT_NINF)
    goto sieve_yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (sieve_yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      sieve_yychar = YYLEX;
    }

  if (sieve_yychar <= YYEOF)
    {
      sieve_yychar = sieve_yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      sieve_yytoken = YYTRANSLATE (sieve_yychar);
      YYDSYMPRINTF ("Next token is", sieve_yytoken, &sieve_yylval, &sieve_yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  sieve_yyn += sieve_yytoken;
  if (sieve_yyn < 0 || YYLAST < sieve_yyn || sieve_yycheck[sieve_yyn] != sieve_yytoken)
    goto sieve_yydefault;
  sieve_yyn = sieve_yytable[sieve_yyn];
  if (sieve_yyn <= 0)
    {
      if (sieve_yyn == 0 || sieve_yyn == YYTABLE_NINF)
	goto sieve_yyerrlab;
      sieve_yyn = -sieve_yyn;
      goto sieve_yyreduce;
    }

  if (sieve_yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", sieve_yytname[sieve_yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (sieve_yychar != YYEOF)
    sieve_yychar = YYEMPTY;

  *++sieve_yyvsp = sieve_yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (sieve_yyerrstatus)
    sieve_yyerrstatus--;

  sieve_yystate = sieve_yyn;
  goto sieve_yynewstate;


/*-----------------------------------------------------------.
| sieve_yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
sieve_yydefault:
  sieve_yyn = sieve_yydefact[sieve_yystate];
  if (sieve_yyn == 0)
    goto sieve_yyerrlab;
  goto sieve_yyreduce;


/*-----------------------------.
| sieve_yyreduce -- Do a reduction.  |
`-----------------------------*/
sieve_yyreduce:
  /* sieve_yyn is the number of a rule to reduce with.  */
  sieve_yylen = sieve_yyr2[sieve_yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  sieve_yyval = sieve_yyvsp[1-sieve_yylen];


  YY_REDUCE_PRINT (sieve_yyn);
  switch (sieve_yyn)
    {
        case 3:
#line 74 "sieve.y"
    { /* to placate bison */ }
    break;

  case 6:
#line 82 "sieve.y"
    {
		 sieve_require (sieve_yyvsp[-1].list);
		 /*  All the items in $2 are registered in memory_pool,
		     so we don't free them */
		 list_destroy (&sieve_yyvsp[-1].list);
		 sieve_yyval.pc = sieve_machine->pc;
	       }
    break;

  case 8:
#line 92 "sieve.y"
    {
		 sieve_machine->prog[sieve_yyvsp[-2].pc].pc = sieve_yyvsp[0].branch.begin - sieve_yyvsp[-2].pc - 1;
		 if (sieve_yyvsp[0].branch.branch)
		   branch_fixup (sieve_yyvsp[0].branch.branch, sieve_machine->pc);
	       }
    break;

  case 9:
#line 100 "sieve.y"
    {
		 sieve_yyval.pc = sieve_machine->pc;
	       }
    break;

  case 10:
#line 106 "sieve.y"
    {
		 if (sieve_yyvsp[0].branch.begin)
		   sieve_machine->prog[sieve_yyvsp[0].branch.cond].pc =
		                  sieve_machine->pc - sieve_yyvsp[0].branch.cond - 1;
		 else
		   {
		     sieve_yyval.branch.begin = sieve_machine->pc;
		     sieve_yyval.branch.branch = 0;
		   }
	       }
    break;

  case 11:
#line 117 "sieve.y"
    {
		 if (sieve_yyvsp[-2].branch.begin)
		   {
		     sieve_machine->prog[sieve_yyvsp[-2].branch.cond].pc = sieve_yyvsp[0].pc - sieve_yyvsp[-2].branch.cond - 1;
		     sieve_machine->prog[sieve_yyvsp[-1].pc].pc = sieve_yyvsp[-2].branch.branch;
		     sieve_yyval.branch.begin = sieve_yyvsp[-2].branch.begin;
		     sieve_yyval.branch.branch = sieve_yyvsp[-1].pc;
		   }
		 else
		   {
		     sieve_yyval.branch.begin = sieve_yyvsp[0].pc;
		     sieve_yyval.branch.branch = sieve_yyvsp[-1].pc;
		   }
	       }
    break;

  case 12:
#line 134 "sieve.y"
    {
		 sieve_yyval.branch.begin = 0;
	       }
    break;

  case 14:
#line 141 "sieve.y"
    {
		 sieve_yyval.branch.begin = sieve_yyvsp[-2].pc; 
		 sieve_yyval.branch.branch = sieve_yyvsp[-3].pc;
		 sieve_yyval.branch.cond = sieve_yyvsp[-1].pc;
	       }
    break;

  case 15:
#line 147 "sieve.y"
    {
		 sieve_machine->prog[sieve_yyvsp[-4].branch.cond].pc = sieve_yyvsp[-2].pc - sieve_yyvsp[-4].branch.cond - 1;
		 sieve_machine->prog[sieve_yyvsp[-3].pc].pc = sieve_yyvsp[-4].branch.branch;
		 sieve_yyval.branch.begin = sieve_yyvsp[-4].branch.begin;
		 sieve_yyval.branch.branch = sieve_yyvsp[-3].pc;
		 sieve_yyval.branch.cond = sieve_yyvsp[-1].pc;
	       }
    break;

  case 16:
#line 157 "sieve.y"
    {
		 sieve_code_instr (instr_branch);
		 sieve_yyval.pc = sieve_machine->pc;
		 sieve_code_number (0);
	       }
    break;

  case 17:
#line 165 "sieve.y"
    {
		 sieve_code_instr (instr_branch);
		 sieve_yyval.pc = sieve_machine->pc;
		 sieve_code_number (0);
	       }
    break;

  case 18:
#line 173 "sieve.y"
    {
		 sieve_yyval.pc = sieve_yyvsp[-1].pc;
	       }
    break;

  case 19:
#line 179 "sieve.y"
    {
		 sieve_yyval.pclist.start = sieve_yyval.pclist.end = sieve_machine->pc;
		 if (sieve_code_instr (instr_brz)
		     || sieve_code_number (0))
		   YYERROR;
	       }
    break;

  case 20:
#line 186 "sieve.y"
    {
		 sieve_machine->prog[sieve_yyvsp[-2].pclist.end+1].pc = sieve_machine->pc;
		 sieve_yyvsp[-2].pclist.end = sieve_machine->pc;
		 if (sieve_code_instr (instr_brz)
		     || sieve_code_number (0))
		   YYERROR;
		 sieve_yyval.pclist = sieve_yyvsp[-2].pclist;
	       }
    break;

  case 21:
#line 197 "sieve.y"
    {
		 sieve_code_instr (instr_brz);
		 sieve_yyval.pc = sieve_machine->pc;
		 sieve_code_number (0);
	       }
    break;

  case 22:
#line 205 "sieve.y"
    { /* to placate bison */ }
    break;

  case 23:
#line 207 "sieve.y"
    {
		 sieve_code_anyof (sieve_yyvsp[-1].pclist.start);
	       }
    break;

  case 24:
#line 211 "sieve.y"
    {
		 sieve_code_allof (sieve_yyvsp[-1].pclist.start);
	       }
    break;

  case 25:
#line 215 "sieve.y"
    {
		 if (sieve_code_instr (instr_not))
		   YYERROR;
	       }
    break;

  case 26:
#line 222 "sieve.y"
    {
		 sieve_yyval.pc = sieve_machine->pc;
	       }
    break;

  case 27:
#line 228 "sieve.y"
    {
		 sieve_register_t *reg = sieve_test_lookup (sieve_machine,
							    sieve_yyvsp[0].command.ident);
		 sieve_yyval.pc = sieve_machine->pc;

		 if (!reg)
		   sieve_compile_error (sieve_filename, sieve_line_num,
                                _("unknown test: %s"),
				sieve_yyvsp[0].command.ident);
		 else if (!reg->required)
		   sieve_compile_error (sieve_filename, sieve_line_num,
                                _("test `%s' has not been required"),
				sieve_yyvsp[0].command.ident);
		 else if (sieve_code_test (reg, sieve_yyvsp[0].command.args))
		   YYERROR;
	       }
    break;

  case 28:
#line 247 "sieve.y"
    {
		 sieve_yyval.command.ident = sieve_yyvsp[-1].string;
		 sieve_yyval.command.args = sieve_yyvsp[0].list;
	       }
    break;

  case 29:
#line 254 "sieve.y"
    {
		 sieve_register_t *reg = sieve_action_lookup (sieve_machine,
							      sieve_yyvsp[0].command.ident);
		 
		 sieve_yyval.pc = sieve_machine->pc;
		 if (!reg)
		   sieve_compile_error (sieve_filename, sieve_line_num,
                                _("unknown action: %s"),
				sieve_yyvsp[0].command.ident);
		 else if (!reg->required)
		   sieve_compile_error (sieve_filename, sieve_line_num,
                                _("action `%s' has not been required"),
				sieve_yyvsp[0].command.ident);
		 else if (sieve_code_action (reg, sieve_yyvsp[0].command.args))
		   YYERROR;
	       }
    break;

  case 30:
#line 273 "sieve.y"
    {
		 sieve_yyval.list = NULL;
	       }
    break;

  case 32:
#line 280 "sieve.y"
    {
		 list_create (&sieve_yyval.list);
		 list_append (sieve_yyval.list, sieve_yyvsp[0].value);
	       }
    break;

  case 33:
#line 285 "sieve.y"
    {
		 list_append (sieve_yyvsp[-1].list, sieve_yyvsp[0].value);
		 sieve_yyval.list = sieve_yyvsp[-1].list;
	       }
    break;

  case 34:
#line 292 "sieve.y"
    {
		 sieve_yyval.value = sieve_value_create (SVT_STRING_LIST, sieve_yyvsp[0].list);
	       }
    break;

  case 35:
#line 296 "sieve.y"
    {
		 sieve_yyval.value = sieve_value_create (SVT_STRING, sieve_yyvsp[0].string);
               }
    break;

  case 36:
#line 300 "sieve.y"
    {
		 sieve_yyval.value = sieve_value_create (SVT_STRING, sieve_yyvsp[0].string);
	       }
    break;

  case 37:
#line 304 "sieve.y"
    {
		 sieve_yyval.value = sieve_value_create (SVT_NUMBER, &sieve_yyvsp[0].number);
	       }
    break;

  case 38:
#line 308 "sieve.y"
    {
		 sieve_yyval.value = sieve_value_create (SVT_TAG, sieve_yyvsp[0].string);
	       }
    break;

  case 39:
#line 314 "sieve.y"
    {
		 list_create (&sieve_yyval.list);
		 list_append (sieve_yyval.list, sieve_yyvsp[0].string);
	       }
    break;

  case 41:
#line 322 "sieve.y"
    {
		 sieve_yyval.list = sieve_yyvsp[-1].list;
	       }
    break;

  case 42:
#line 328 "sieve.y"
    {
		 list_create (&sieve_yyval.list);
		 list_append (sieve_yyval.list, sieve_yyvsp[0].string);
	       }
    break;

  case 43:
#line 333 "sieve.y"
    {
		 list_append (sieve_yyvsp[-2].list, sieve_yyvsp[0].string);
		 sieve_yyval.list = sieve_yyvsp[-2].list;
	       }
    break;


    }

/* Line 991 of yacc.c.  */
#line 1417 "y.tab.c"

  sieve_yyvsp -= sieve_yylen;
  sieve_yyssp -= sieve_yylen;


  YY_STACK_PRINT (sieve_yyss, sieve_yyssp);

  *++sieve_yyvsp = sieve_yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  sieve_yyn = sieve_yyr1[sieve_yyn];

  sieve_yystate = sieve_yypgoto[sieve_yyn - YYNTOKENS] + *sieve_yyssp;
  if (0 <= sieve_yystate && sieve_yystate <= YYLAST && sieve_yycheck[sieve_yystate] == *sieve_yyssp)
    sieve_yystate = sieve_yytable[sieve_yystate];
  else
    sieve_yystate = sieve_yydefgoto[sieve_yyn - YYNTOKENS];

  goto sieve_yynewstate;


/*------------------------------------.
| sieve_yyerrlab -- here on detecting error |
`------------------------------------*/
sieve_yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!sieve_yyerrstatus)
    {
      ++sieve_yynerrs;
#if YYERROR_VERBOSE
      sieve_yyn = sieve_yypact[sieve_yystate];

      if (YYPACT_NINF < sieve_yyn && sieve_yyn < YYLAST)
	{
	  YYSIZE_T sieve_yysize = 0;
	  int sieve_yytype = YYTRANSLATE (sieve_yychar);
	  char *sieve_yymsg;
	  int sieve_yyx, sieve_yycount;

	  sieve_yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (sieve_yyx = sieve_yyn < 0 ? -sieve_yyn : 0;
	       sieve_yyx < (int) (sizeof (sieve_yytname) / sizeof (char *)); sieve_yyx++)
	    if (sieve_yycheck[sieve_yyx + sieve_yyn] == sieve_yyx && sieve_yyx != YYTERROR)
	      sieve_yysize += sieve_yystrlen (sieve_yytname[sieve_yyx]) + 15, sieve_yycount++;
	  sieve_yysize += sieve_yystrlen ("syntax error, unexpected ") + 1;
	  sieve_yysize += sieve_yystrlen (sieve_yytname[sieve_yytype]);
	  sieve_yymsg = (char *) YYSTACK_ALLOC (sieve_yysize);
	  if (sieve_yymsg != 0)
	    {
	      char *sieve_yyp = sieve_yystpcpy (sieve_yymsg, "syntax error, unexpected ");
	      sieve_yyp = sieve_yystpcpy (sieve_yyp, sieve_yytname[sieve_yytype]);

	      if (sieve_yycount < 5)
		{
		  sieve_yycount = 0;
		  for (sieve_yyx = sieve_yyn < 0 ? -sieve_yyn : 0;
		       sieve_yyx < (int) (sizeof (sieve_yytname) / sizeof (char *));
		       sieve_yyx++)
		    if (sieve_yycheck[sieve_yyx + sieve_yyn] == sieve_yyx && sieve_yyx != YYTERROR)
		      {
			const char *sieve_yyq = ! sieve_yycount ? ", expecting " : " or ";
			sieve_yyp = sieve_yystpcpy (sieve_yyp, sieve_yyq);
			sieve_yyp = sieve_yystpcpy (sieve_yyp, sieve_yytname[sieve_yyx]);
			sieve_yycount++;
		      }
		}
	      sieve_yyerror (sieve_yymsg);
	      YYSTACK_FREE (sieve_yymsg);
	    }
	  else
	    sieve_yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	sieve_yyerror ("syntax error");
    }



  if (sieve_yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (sieve_yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (sieve_yyss < sieve_yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", sieve_yystos[*sieve_yyssp], sieve_yyvsp, sieve_yylsp);
	      sieve_yydestruct (sieve_yystos[*sieve_yyssp], sieve_yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", sieve_yytoken, &sieve_yylval, &sieve_yylloc);
      sieve_yydestruct (sieve_yytoken, &sieve_yylval);
      sieve_yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto sieve_yyerrlab2;


/*----------------------------------------------------.
| sieve_yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
sieve_yyerrlab1:

  /* Suppress GCC warning that sieve_yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto sieve_yyerrlab2;


/*---------------------------------------------------------------.
| sieve_yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
sieve_yyerrlab2:
  sieve_yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      sieve_yyn = sieve_yypact[sieve_yystate];
      if (sieve_yyn != YYPACT_NINF)
	{
	  sieve_yyn += YYTERROR;
	  if (0 <= sieve_yyn && sieve_yyn <= YYLAST && sieve_yycheck[sieve_yyn] == YYTERROR)
	    {
	      sieve_yyn = sieve_yytable[sieve_yyn];
	      if (0 < sieve_yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (sieve_yyssp == sieve_yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", sieve_yystos[*sieve_yyssp], sieve_yyvsp, sieve_yylsp);
      sieve_yydestruct (sieve_yystos[sieve_yystate], sieve_yyvsp);
      sieve_yyvsp--;
      sieve_yystate = *--sieve_yyssp;

      YY_STACK_PRINT (sieve_yyss, sieve_yyssp);
    }

  if (sieve_yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++sieve_yyvsp = sieve_yylval;


  sieve_yystate = sieve_yyn;
  goto sieve_yynewstate;


/*-------------------------------------.
| sieve_yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
sieve_yyacceptlab:
  sieve_yyresult = 0;
  goto sieve_yyreturn;

/*-----------------------------------.
| sieve_yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
sieve_yyabortlab:
  sieve_yyresult = 1;
  goto sieve_yyreturn;

#ifndef sieve_yyoverflow
/*----------------------------------------------.
| sieve_yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
sieve_yyoverflowlab:
  sieve_yyerror ("parser stack overflow");
  sieve_yyresult = 2;
  /* Fall through.  */
#endif

sieve_yyreturn:
#ifndef sieve_yyoverflow
  if (sieve_yyss != sieve_yyssa)
    YYSTACK_FREE (sieve_yyss);
#endif
  return sieve_yyresult;
}


#line 339 "sieve.y"


int
sieve_yyerror (char *s)
{
  sieve_compile_error (sieve_filename, sieve_line_num, "%s", s);
  return 0;
}

int
sieve_machine_init (sieve_machine_t *pmach, void *data)
{
  int rc;
  sieve_machine_t mach;
  
  mach = malloc (sizeof (*mach));
  if (!mach)
    return ENOMEM;
  memset (mach, 0, sizeof (*mach));
  rc = list_create (&mach->memory_pool);
  if (rc)
    {
      free (mach);
      return rc;
    }
  
  mach->data = data;
  mach->error_printer = _sieve_default_error_printer;
  mach->parse_error_printer = _sieve_default_parse_error;
  *pmach = mach;
  return 0;
}

void
sieve_set_error (sieve_machine_t mach, sieve_printf_t error_printer)
{
  mach->error_printer = error_printer ?
                           error_printer : _sieve_default_error_printer;
}

void
sieve_set_parse_error (sieve_machine_t mach, sieve_parse_error_t p)
{
  mach->parse_error_printer = p ? p : _sieve_default_parse_error;
}

void
sieve_set_debug (sieve_machine_t mach, sieve_printf_t debug)
{
  mach->debug_printer = debug;
}

void
sieve_set_debug_level (sieve_machine_t mach, mu_debug_t dbg, int level)
{
  mach->mu_debug = dbg;
  mach->debug_level = level;
}

void
sieve_set_logger (sieve_machine_t mach, sieve_action_log_t logger)
{
  mach->logger = logger;
}

void
sieve_set_ticket (sieve_machine_t mach, ticket_t ticket)
{
  mach->ticket = ticket;
}

ticket_t
sieve_get_ticket (sieve_machine_t mach)
{
  return mach->ticket;
}

mailer_t
sieve_get_mailer (sieve_machine_t mach)
{
  if (!mach->mailer)
    {
      mailer_create (&mach->mailer, NULL);
      if (mach->mu_debug)
	mailer_set_debug (mach->mailer, mach->mu_debug);
    }

  return mach->mailer;
}

void
sieve_set_mailer (sieve_machine_t mach, mailer_t mailer)
{
  mailer_destroy (&mach->mailer);
  mach->mailer = mailer;
}

#define MAILER_DAEMON_PFX "MAILER-DAEMON@"

char *
sieve_get_daemon_email (sieve_machine_t mach)
{
  if (!mach->daemon_email)
    {
      const char *domain = NULL;
      
      mu_get_user_email_domain (&domain);
      mach->daemon_email = sieve_malloc (mach,
					 sizeof(MAILER_DAEMON_PFX) +
					 strlen (domain));
      sprintf (mach->daemon_email, "%s%s", MAILER_DAEMON_PFX, domain);
    }
  return mach->daemon_email;
}

void
sieve_set_daemon_email (sieve_machine_t mach, const char *email)
{
  sieve_mfree (mach, (void *)mach->daemon_email);
  mach->daemon_email = sieve_mstrdup (mach, email);
}

struct sieve_destr_record
{
  sieve_destructor_t destr;
  void *ptr;
};

int
sieve_machine_add_destructor (sieve_machine_t mach, sieve_destructor_t destr,
			      void *ptr)
{
  struct sieve_destr_record *p;

  if (!mach->destr_list && list_create (&mach->destr_list))
    return 1;
  p = sieve_malloc (mach, sizeof (*p));
  if (!p)
    return 1;
  p->destr = destr;
  p->ptr = ptr;
  return list_prepend (mach->destr_list, p);
}

static int
_run_destructor (void *data, void *unused)
{
  struct sieve_destr_record *p = data;
  p->destr (p->ptr);
  return 0;
}

void
sieve_machine_destroy (sieve_machine_t *pmach)
{
  sieve_machine_t mach = *pmach;
  mailer_destroy (&mach->mailer);
  list_do (mach->destr_list, _run_destructor, NULL);
  list_destroy (&mach->destr_list);
  list_destroy (&mach->action_list);
  list_destroy (&mach->test_list);
  list_destroy (&mach->comp_list);
  list_destroy (&mach->source_list);
  sieve_slist_destroy (&mach->memory_pool);
  free (mach);
  *pmach = NULL;
}

static int
string_comp (const void *item, const void *value)
{
  return strcmp (item, value);
}

void
sieve_machine_begin (sieve_machine_t mach, const char *file)
{
  sieve_machine = mach;
  sieve_error_count = 0;
  sieve_code_instr (NULL);

  list_create (&mach->source_list);
  list_set_comparator (mach->source_list, string_comp);
  
  sieve_register_standard_actions (mach);
  sieve_register_standard_tests (mach);
  sieve_register_standard_comparators (mach);
}

void
sieve_machine_finish (sieve_machine_t mach)
{
  sieve_code_instr (NULL);
}

int
sieve_compile (sieve_machine_t mach, const char *name)
{
  int rc;
  
  sieve_machine_begin (mach, name);

  if (sieve_lex_begin (name) == 0)
    {
      rc = sieve_yyparse ();
      if (sieve_error_count)
	rc = 1;
      sieve_lex_finish ();
    }
  else
    rc = 1;
  
  sieve_machine_finish (mach);
  if (rc)
    sieve_machine_destroy (&mach);
  return rc;
}

static void
_branch_fixup (size_t start, size_t end)
{
  size_t prev = sieve_machine->prog[start].pc;
  if (!prev)
    return;
  branch_fixup (prev, end);
  sieve_machine->prog[prev].pc = end - prev - 1;
}

void
branch_fixup (size_t start, size_t end)
{
  _branch_fixup (start, end);
  sieve_machine->prog[start].pc = end - start - 1;
}

