/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with ali_yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum ali_yytokentype {
     STRING = 258
   };
#endif
#define STRING 258




/* Copy the first part of user declarations.  */
#line 1 "mh_alias.y"

/* GNU Mailutils -- a suite of utilities for electronic mail
   Copyright (C) 2003, 2004 Free Software Foundation, Inc.

   GNU Mailutils is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GNU Mailutils is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Mailutils; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#include <mh.h>
#include <pwd.h>
#include <grp.h>
#include <sys/types.h>
  
struct mh_alias
{
  char *name;
  list_t rcpt_list;
  int inclusive;
};

static list_t alias_list;

static list_t
list_create_or_die ()
{
  int status;
  list_t list;

  status = list_create (&list);
  if (status)
    {
      ali_parse_error (_("can't create list: %s"), mu_strerror (status));
      exit (1);
    }
  return list;
}

static char *
ali_list_to_string (list_t *plist)
{
  size_t n;
  char *string;
  
  list_count (*plist, &n);
  if (n == 1)
    {
      list_get (*plist, 0, (void **)&string);
    }
  else
    {
      char *p;
      size_t length = 0;
      iterator_t itr;
      list_get_iterator (*plist, &itr);
      for (iterator_first (itr); !iterator_is_done (itr); iterator_next(itr))
	{
	  char *s;
	  iterator_current (itr, (void**) &s);
	  length += strlen (s) + 1;
	}
  
      string = xmalloc (length + 1);
      p = string;
      for (iterator_first (itr); !iterator_is_done (itr); iterator_next(itr))
	{
	  char *s;
	  iterator_current (itr, (void**) &s);
	  strcpy (p, s);
	  p += strlen (s);
	  *p++ = ' ';
	}
      *--p = 0;
      iterator_destroy (&itr);
    }
  list_destroy (plist);
  return string;
}

static list_t unix_group_to_list __P((char *name));
static list_t unix_gid_to_list __P((char *name));
static list_t unix_passwd_to_list __P((void));

int ali_yyerror __P((char *s));
int ali_yylex __P((void));



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 99 "mh_alias.y"
typedef union YYSTYPE {
  char *string;
  list_t list;
  struct mh_alias *alias;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 185 "y.tab.c"
# define ali_yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 197 "y.tab.c"

#if ! defined (ali_yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (ali_yyoverflow) || YYERROR_VERBOSE */


#if (! defined (ali_yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union ali_yyalloc
{
  short ali_yyss;
  YYSTYPE ali_yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union ali_yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T ali_yyi;		\
	  for (ali_yyi = 0; ali_yyi < (Count); ali_yyi++)	\
	    (To)[ali_yyi] = (From)[ali_yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T ali_yynewbytes;						\
	YYCOPY (&ali_yyptr->Stack, Stack, ali_yysize);				\
	Stack = &ali_yyptr->Stack;						\
	ali_yynewbytes = ali_yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	ali_yyptr += ali_yynewbytes / sizeof (*ali_yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char ali_yysigned_char;
#else
   typedef short ali_yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   25

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  11
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  11
/* YYNRULES -- Number of rules. */
#define YYNRULES  23
/* YYNRULES -- Number of states. */
#define YYNSTATES  31

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   258

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? ali_yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char ali_yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     9,     8,    10,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     5,     6,
       2,     7,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char ali_yyprhs[] =
{
       0,     0,     3,     4,     6,     9,    12,    16,    18,    22,
      24,    27,    28,    33,    34,    39,    41,    44,    47,    49,
      51,    55,    57,    59
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const ali_yysigned_char ali_yyrhs[] =
{
      12,     0,    -1,    -1,    13,    -1,    13,    14,    -1,    14,
      13,    -1,    14,    13,    14,    -1,    15,    -1,    13,    14,
      15,    -1,     4,    -1,    14,     4,    -1,    -1,     3,     5,
      16,    18,    -1,    -1,     3,     6,    17,    18,    -1,    19,
      -1,     7,     3,    -1,     8,     3,    -1,     9,    -1,    20,
      -1,    19,    10,    20,    -1,    21,    -1,     3,    -1,    21,
       3,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char ali_yyrline[] =
{
       0,   112,   112,   113,   114,   115,   116,   119,   125,   131,
     132,   135,   135,   143,   143,   153,   154,   159,   164,   170,
     175,   182,   188,   193
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const ali_yytname[] =
{
  "$end", "error", "$undefined", "STRING", "'\\n'", "':'", "';'", "'='", 
  "'+'", "'*'", "','", "$accept", "input", "alias_list", "nl", "alias", 
  "@1", "@2", "address_group", "address_list", "address", "string_list", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short ali_yytoknum[] =
{
       0,   256,   257,   258,    10,    58,    59,    61,    43,    42,
      44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char ali_yyr1[] =
{
       0,    11,    12,    12,    12,    12,    12,    13,    13,    14,
      14,    16,    15,    17,    15,    18,    18,    18,    18,    19,
      19,    20,    21,    21
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char ali_yyr2[] =
{
       0,     2,     0,     1,     2,     2,     3,     1,     3,     1,
       2,     0,     4,     0,     4,     1,     2,     2,     1,     1,
       3,     1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char ali_yydefact[] =
{
       2,     0,     9,     0,     3,     0,     7,    11,    13,     1,
       4,    10,     5,     0,     0,     8,     6,    22,     0,     0,
      18,    12,    15,    19,    21,    14,    16,    17,     0,    23,
      20
};

/* YYDEFGOTO[NTERM-NUM]. */
static const ali_yysigned_char ali_yydefgoto[] =
{
      -1,     3,     4,     5,     6,    13,    14,    21,    22,    23,
      24
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -8
static const ali_yysigned_char ali_yypact[] =
{
       7,     8,    -8,     2,     0,    12,    -8,    -8,    -8,    -8,
      12,    -8,     0,    -2,    -2,    -8,    12,    -8,     9,    14,
      -8,    -8,    10,    -8,    15,    -8,    -8,    -8,    16,    -8,
      -8
};

/* YYPGOTO[NTERM-NUM].  */
static const ali_yysigned_char ali_yypgoto[] =
{
      -8,    -8,    17,    -4,    -7,    -8,    -8,    11,    -8,    -5,
      -8
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char ali_yytable[] =
{
      10,    17,     9,    15,     2,    18,    19,    20,    16,    15,
       1,     2,    26,     7,     8,     1,    11,    27,    29,    17,
      28,     0,    12,    30,     0,    25
};

static const ali_yysigned_char ali_yycheck[] =
{
       4,     3,     0,    10,     4,     7,     8,     9,    12,    16,
       3,     4,     3,     5,     6,     3,     4,     3,     3,     3,
      10,    -1,     5,    28,    -1,    14
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char ali_yystos[] =
{
       0,     3,     4,    12,    13,    14,    15,     5,     6,     0,
      14,     4,    13,    16,    17,    15,    14,     3,     7,     8,
       9,    18,    19,    20,    21,    18,     3,     3,    10,     3,
      20
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define ali_yyerrok		(ali_yyerrstatus = 0)
#define ali_yyclearin	(ali_yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto ali_yyacceptlab
#define YYABORT		goto ali_yyabortlab
#define YYERROR		goto ali_yyerrlab1

/* Like YYERROR except do call ali_yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto ali_yyerrlab

#define YYRECOVERING()  (!!ali_yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (ali_yychar == YYEMPTY && ali_yylen == 1)				\
    {								\
      ali_yychar = (Token);						\
      ali_yylval = (Value);						\
      ali_yytoken = YYTRANSLATE (ali_yychar);				\
      YYPOPSTACK;						\
      goto ali_yybackup;						\
    }								\
  else								\
    { 								\
      ali_yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `ali_yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX ali_yylex (YYLEX_PARAM)
#else
# define YYLEX ali_yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (ali_yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (ali_yydebug)					\
    ali_yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (ali_yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      ali_yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| ali_yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
ali_yy_stack_print (short *bottom, short *top)
#else
static void
ali_yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (ali_yydebug)							\
    ali_yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
ali_yy_reduce_print (int ali_yyrule)
#else
static void
ali_yy_reduce_print (ali_yyrule)
    int ali_yyrule;
#endif
{
  int ali_yyi;
  unsigned int ali_yylineno = ali_yyrline[ali_yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             ali_yyrule - 1, ali_yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (ali_yyi = ali_yyprhs[ali_yyrule]; 0 <= ali_yyrhs[ali_yyi]; ali_yyi++)
    YYFPRINTF (stderr, "%s ", ali_yytname [ali_yyrhs[ali_yyi]]);
  YYFPRINTF (stderr, "-> %s\n", ali_yytname [ali_yyr1[ali_yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (ali_yydebug)				\
    ali_yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int ali_yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef ali_yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define ali_yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
ali_yystrlen (const char *ali_yystr)
#   else
ali_yystrlen (ali_yystr)
     const char *ali_yystr;
#   endif
{
  register const char *ali_yys = ali_yystr;

  while (*ali_yys++ != '\0')
    continue;

  return ali_yys - ali_yystr - 1;
}
#  endif
# endif

# ifndef ali_yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define ali_yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
ali_yystpcpy (char *ali_yydest, const char *ali_yysrc)
#   else
ali_yystpcpy (ali_yydest, ali_yysrc)
     char *ali_yydest;
     const char *ali_yysrc;
#   endif
{
  register char *ali_yyd = ali_yydest;
  register const char *ali_yys = ali_yysrc;

  while ((*ali_yyd++ = *ali_yys++) != '\0')
    continue;

  return ali_yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
ali_yysymprint (FILE *ali_yyoutput, int ali_yytype, YYSTYPE *ali_yyvaluep)
#else
static void
ali_yysymprint (ali_yyoutput, ali_yytype, ali_yyvaluep)
    FILE *ali_yyoutput;
    int ali_yytype;
    YYSTYPE *ali_yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) ali_yyvaluep;

  if (ali_yytype < YYNTOKENS)
    {
      YYFPRINTF (ali_yyoutput, "token %s (", ali_yytname[ali_yytype]);
# ifdef YYPRINT
      YYPRINT (ali_yyoutput, ali_yytoknum[ali_yytype], *ali_yyvaluep);
# endif
    }
  else
    YYFPRINTF (ali_yyoutput, "nterm %s (", ali_yytname[ali_yytype]);

  switch (ali_yytype)
    {
      default:
        break;
    }
  YYFPRINTF (ali_yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
ali_yydestruct (int ali_yytype, YYSTYPE *ali_yyvaluep)
#else
static void
ali_yydestruct (ali_yytype, ali_yyvaluep)
    int ali_yytype;
    YYSTYPE *ali_yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) ali_yyvaluep;

  switch (ali_yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int ali_yyparse (void *YYPARSE_PARAM);
# else
int ali_yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int ali_yyparse (void);
#else
int ali_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int ali_yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE ali_yylval;

/* Number of syntax errors so far.  */
int ali_yynerrs;



/*----------.
| ali_yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int ali_yyparse (void *YYPARSE_PARAM)
# else
int ali_yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
ali_yyparse (void)
#else
int
ali_yyparse ()

#endif
#endif
{
  
  register int ali_yystate;
  register int ali_yyn;
  int ali_yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int ali_yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int ali_yytoken = 0;

  /* Three stacks and their tools:
     `ali_yyss': related to states,
     `ali_yyvs': related to semantic values,
     `ali_yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow ali_yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	ali_yyssa[YYINITDEPTH];
  short *ali_yyss = ali_yyssa;
  register short *ali_yyssp;

  /* The semantic value stack.  */
  YYSTYPE ali_yyvsa[YYINITDEPTH];
  YYSTYPE *ali_yyvs = ali_yyvsa;
  register YYSTYPE *ali_yyvsp;



#define YYPOPSTACK   (ali_yyvsp--, ali_yyssp--)

  YYSIZE_T ali_yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE ali_yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int ali_yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  ali_yystate = 0;
  ali_yyerrstatus = 0;
  ali_yynerrs = 0;
  ali_yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  ali_yyssp = ali_yyss;
  ali_yyvsp = ali_yyvs;

  goto ali_yysetstate;

/*------------------------------------------------------------.
| ali_yynewstate -- Push a new state, which is found in ali_yystate.  |
`------------------------------------------------------------*/
 ali_yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  ali_yyssp++;

 ali_yysetstate:
  *ali_yyssp = ali_yystate;

  if (ali_yyss + ali_yystacksize - 1 <= ali_yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T ali_yysize = ali_yyssp - ali_yyss + 1;

#ifdef ali_yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *ali_yyvs1 = ali_yyvs;
	short *ali_yyss1 = ali_yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if ali_yyoverflow is a macro.  */
	ali_yyoverflow ("parser stack overflow",
		    &ali_yyss1, ali_yysize * sizeof (*ali_yyssp),
		    &ali_yyvs1, ali_yysize * sizeof (*ali_yyvsp),

		    &ali_yystacksize);

	ali_yyss = ali_yyss1;
	ali_yyvs = ali_yyvs1;
      }
#else /* no ali_yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto ali_yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= ali_yystacksize)
	goto ali_yyoverflowlab;
      ali_yystacksize *= 2;
      if (YYMAXDEPTH < ali_yystacksize)
	ali_yystacksize = YYMAXDEPTH;

      {
	short *ali_yyss1 = ali_yyss;
	union ali_yyalloc *ali_yyptr =
	  (union ali_yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (ali_yystacksize));
	if (! ali_yyptr)
	  goto ali_yyoverflowlab;
	YYSTACK_RELOCATE (ali_yyss);
	YYSTACK_RELOCATE (ali_yyvs);

#  undef YYSTACK_RELOCATE
	if (ali_yyss1 != ali_yyssa)
	  YYSTACK_FREE (ali_yyss1);
      }
# endif
#endif /* no ali_yyoverflow */

      ali_yyssp = ali_yyss + ali_yysize - 1;
      ali_yyvsp = ali_yyvs + ali_yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) ali_yystacksize));

      if (ali_yyss + ali_yystacksize - 1 <= ali_yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", ali_yystate));

  goto ali_yybackup;

/*-----------.
| ali_yybackup.  |
`-----------*/
ali_yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* ali_yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  ali_yyn = ali_yypact[ali_yystate];
  if (ali_yyn == YYPACT_NINF)
    goto ali_yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (ali_yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      ali_yychar = YYLEX;
    }

  if (ali_yychar <= YYEOF)
    {
      ali_yychar = ali_yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      ali_yytoken = YYTRANSLATE (ali_yychar);
      YYDSYMPRINTF ("Next token is", ali_yytoken, &ali_yylval, &ali_yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  ali_yyn += ali_yytoken;
  if (ali_yyn < 0 || YYLAST < ali_yyn || ali_yycheck[ali_yyn] != ali_yytoken)
    goto ali_yydefault;
  ali_yyn = ali_yytable[ali_yyn];
  if (ali_yyn <= 0)
    {
      if (ali_yyn == 0 || ali_yyn == YYTABLE_NINF)
	goto ali_yyerrlab;
      ali_yyn = -ali_yyn;
      goto ali_yyreduce;
    }

  if (ali_yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", ali_yytname[ali_yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (ali_yychar != YYEOF)
    ali_yychar = YYEMPTY;

  *++ali_yyvsp = ali_yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (ali_yyerrstatus)
    ali_yyerrstatus--;

  ali_yystate = ali_yyn;
  goto ali_yynewstate;


/*-----------------------------------------------------------.
| ali_yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
ali_yydefault:
  ali_yyn = ali_yydefact[ali_yystate];
  if (ali_yyn == 0)
    goto ali_yyerrlab;
  goto ali_yyreduce;


/*-----------------------------.
| ali_yyreduce -- Do a reduction.  |
`-----------------------------*/
ali_yyreduce:
  /* ali_yyn is the number of a rule to reduce with.  */
  ali_yylen = ali_yyr2[ali_yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  ali_yyval = ali_yyvsp[1-ali_yylen];


  YY_REDUCE_PRINT (ali_yyn);
  switch (ali_yyn)
    {
        case 7:
#line 120 "mh_alias.y"
    {
		 if (!alias_list)
		   alias_list = list_create_or_die ();
		 list_append (alias_list, ali_yyvsp[0].alias);
	       }
    break;

  case 8:
#line 126 "mh_alias.y"
    {
		 list_append (alias_list, ali_yyvsp[0].alias);
	       }
    break;

  case 11:
#line 135 "mh_alias.y"
    { ali_verbatim (1); }
    break;

  case 12:
#line 136 "mh_alias.y"
    {
		 ali_verbatim (0);
		 ali_yyval.alias = xmalloc (sizeof (*ali_yyval.alias));
		 ali_yyval.alias->name = ali_yyvsp[-3].string;
		 ali_yyval.alias->rcpt_list = ali_yyvsp[0].list;
		 ali_yyval.alias->inclusive = 0;
	       }
    break;

  case 13:
#line 143 "mh_alias.y"
    { ali_verbatim (1); }
    break;

  case 14:
#line 144 "mh_alias.y"
    {
		 ali_verbatim (0);
		 ali_yyval.alias = xmalloc (sizeof (*ali_yyval.alias));
		 ali_yyval.alias->name = ali_yyvsp[-3].string;
		 ali_yyval.alias->rcpt_list = ali_yyvsp[0].list;
		 ali_yyval.alias->inclusive = 1;
	       }
    break;

  case 16:
#line 155 "mh_alias.y"
    {
		 ali_yyval.list = unix_group_to_list (ali_yyvsp[0].string);
		 free (ali_yyvsp[0].string);
	       }
    break;

  case 17:
#line 160 "mh_alias.y"
    {
		 ali_yyval.list = unix_gid_to_list (ali_yyvsp[0].string);
		 free (ali_yyvsp[0].string);
	       }
    break;

  case 18:
#line 165 "mh_alias.y"
    {
		 ali_yyval.list = unix_passwd_to_list ();
	       }
    break;

  case 19:
#line 171 "mh_alias.y"
    {
		 ali_yyval.list = list_create_or_die ();
		 list_append (ali_yyval.list, ali_yyvsp[0].string);
	       }
    break;

  case 20:
#line 176 "mh_alias.y"
    {
		 list_append (ali_yyvsp[-2].list, ali_yyvsp[0].string);
		 ali_yyval.list = ali_yyvsp[-2].list;
	       }
    break;

  case 21:
#line 183 "mh_alias.y"
    {
		 ali_yyval.string = ali_list_to_string (&ali_yyvsp[0].list);
	       }
    break;

  case 22:
#line 189 "mh_alias.y"
    {
		 list_create(&ali_yyval.list);
		 list_append(ali_yyval.list, ali_yyvsp[0].string);
	       }
    break;

  case 23:
#line 194 "mh_alias.y"
    {
		 list_append(ali_yyvsp[-1].list, ali_yyvsp[0].string);
		 ali_yyval.list = ali_yyvsp[-1].list;
	       }
    break;


    }

/* Line 991 of yacc.c.  */
#line 1198 "y.tab.c"

  ali_yyvsp -= ali_yylen;
  ali_yyssp -= ali_yylen;


  YY_STACK_PRINT (ali_yyss, ali_yyssp);

  *++ali_yyvsp = ali_yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  ali_yyn = ali_yyr1[ali_yyn];

  ali_yystate = ali_yypgoto[ali_yyn - YYNTOKENS] + *ali_yyssp;
  if (0 <= ali_yystate && ali_yystate <= YYLAST && ali_yycheck[ali_yystate] == *ali_yyssp)
    ali_yystate = ali_yytable[ali_yystate];
  else
    ali_yystate = ali_yydefgoto[ali_yyn - YYNTOKENS];

  goto ali_yynewstate;


/*------------------------------------.
| ali_yyerrlab -- here on detecting error |
`------------------------------------*/
ali_yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!ali_yyerrstatus)
    {
      ++ali_yynerrs;
#if YYERROR_VERBOSE
      ali_yyn = ali_yypact[ali_yystate];

      if (YYPACT_NINF < ali_yyn && ali_yyn < YYLAST)
	{
	  YYSIZE_T ali_yysize = 0;
	  int ali_yytype = YYTRANSLATE (ali_yychar);
	  char *ali_yymsg;
	  int ali_yyx, ali_yycount;

	  ali_yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (ali_yyx = ali_yyn < 0 ? -ali_yyn : 0;
	       ali_yyx < (int) (sizeof (ali_yytname) / sizeof (char *)); ali_yyx++)
	    if (ali_yycheck[ali_yyx + ali_yyn] == ali_yyx && ali_yyx != YYTERROR)
	      ali_yysize += ali_yystrlen (ali_yytname[ali_yyx]) + 15, ali_yycount++;
	  ali_yysize += ali_yystrlen ("syntax error, unexpected ") + 1;
	  ali_yysize += ali_yystrlen (ali_yytname[ali_yytype]);
	  ali_yymsg = (char *) YYSTACK_ALLOC (ali_yysize);
	  if (ali_yymsg != 0)
	    {
	      char *ali_yyp = ali_yystpcpy (ali_yymsg, "syntax error, unexpected ");
	      ali_yyp = ali_yystpcpy (ali_yyp, ali_yytname[ali_yytype]);

	      if (ali_yycount < 5)
		{
		  ali_yycount = 0;
		  for (ali_yyx = ali_yyn < 0 ? -ali_yyn : 0;
		       ali_yyx < (int) (sizeof (ali_yytname) / sizeof (char *));
		       ali_yyx++)
		    if (ali_yycheck[ali_yyx + ali_yyn] == ali_yyx && ali_yyx != YYTERROR)
		      {
			const char *ali_yyq = ! ali_yycount ? ", expecting " : " or ";
			ali_yyp = ali_yystpcpy (ali_yyp, ali_yyq);
			ali_yyp = ali_yystpcpy (ali_yyp, ali_yytname[ali_yyx]);
			ali_yycount++;
		      }
		}
	      ali_yyerror (ali_yymsg);
	      YYSTACK_FREE (ali_yymsg);
	    }
	  else
	    ali_yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	ali_yyerror ("syntax error");
    }



  if (ali_yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (ali_yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (ali_yyss < ali_yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", ali_yystos[*ali_yyssp], ali_yyvsp, ali_yylsp);
	      ali_yydestruct (ali_yystos[*ali_yyssp], ali_yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", ali_yytoken, &ali_yylval, &ali_yylloc);
      ali_yydestruct (ali_yytoken, &ali_yylval);
      ali_yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto ali_yyerrlab2;


/*----------------------------------------------------.
| ali_yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
ali_yyerrlab1:

  /* Suppress GCC warning that ali_yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto ali_yyerrlab2;


/*---------------------------------------------------------------.
| ali_yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
ali_yyerrlab2:
  ali_yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      ali_yyn = ali_yypact[ali_yystate];
      if (ali_yyn != YYPACT_NINF)
	{
	  ali_yyn += YYTERROR;
	  if (0 <= ali_yyn && ali_yyn <= YYLAST && ali_yycheck[ali_yyn] == YYTERROR)
	    {
	      ali_yyn = ali_yytable[ali_yyn];
	      if (0 < ali_yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (ali_yyssp == ali_yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", ali_yystos[*ali_yyssp], ali_yyvsp, ali_yylsp);
      ali_yydestruct (ali_yystos[ali_yystate], ali_yyvsp);
      ali_yyvsp--;
      ali_yystate = *--ali_yyssp;

      YY_STACK_PRINT (ali_yyss, ali_yyssp);
    }

  if (ali_yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++ali_yyvsp = ali_yylval;


  ali_yystate = ali_yyn;
  goto ali_yynewstate;


/*-------------------------------------.
| ali_yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
ali_yyacceptlab:
  ali_yyresult = 0;
  goto ali_yyreturn;

/*-----------------------------------.
| ali_yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
ali_yyabortlab:
  ali_yyresult = 1;
  goto ali_yyreturn;

#ifndef ali_yyoverflow
/*----------------------------------------------.
| ali_yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
ali_yyoverflowlab:
  ali_yyerror ("parser stack overflow");
  ali_yyresult = 2;
  /* Fall through.  */
#endif

ali_yyreturn:
#ifndef ali_yyoverflow
  if (ali_yyss != ali_yyssa)
    YYSTACK_FREE (ali_yyss);
#endif
  return ali_yyresult;
}


#line 200 "mh_alias.y"


static list_t
ali_list_dup (list_t src)
{
  list_t dst;
  iterator_t itr;

  if (list_create (&dst))
    return NULL;

  if (list_get_iterator (src, &itr))
    {
      list_destroy (&dst);
      return NULL;
    }
  
  for (iterator_first (itr); !iterator_is_done (itr); iterator_next (itr))
    {
      void *data;
      iterator_current (itr, (void **)&data);
      list_append (dst, data);
    }
  iterator_destroy (&itr);
  return dst;
}

static int
ali_member (list_t list, char *name)
{
  iterator_t itr;
  int found = 0;

  if (list_get_iterator (list, &itr))
    return 0;
  for (iterator_first (itr); !found && !iterator_is_done (itr);
       iterator_next (itr))
    {
      char *item;
      address_t tmp;
      
      iterator_current (itr, (void **)&item);
      if (strcmp (item, name) == 0)
	found = 1;
      else if (address_create (&tmp, item) == 0)
	{
	  found = address_contains_email (tmp, name);
	  address_destroy (&tmp);
	}
    }
  iterator_destroy (&itr);
  return found;
}

int
aliascmp (char *pattern, char *name)
{
  int len = strlen (pattern);

  if (len > 1 && pattern[len - 1] == '*')
    return strncmp (pattern, name, len - 2);
  return strcmp (pattern, name);
}


int
_insert_list (list_t list, void *prev, list_t new_list)
{
  iterator_t itr;

  if (list_get_iterator (new_list, &itr))
    return 1;
  for (iterator_first (itr); !iterator_is_done (itr); iterator_next (itr))
    {
      void *item;
      
      iterator_current (itr, &item);
      list_insert (list, prev, item);
      prev = item;
    }
  iterator_destroy (&itr);
  return 0;
}

static int mh_alias_get_internal __P((char *name, iterator_t start,
				      list_t *return_list, int *inclusive));

int
alias_expand_list (list_t name_list, iterator_t orig_itr, int *inclusive)
{
  iterator_t itr;

  if (list_get_iterator (name_list, &itr))
    return 1;
  for (iterator_first (itr); !iterator_is_done (itr); iterator_next (itr))
    {
      char *name;
      list_t exlist;
      
      iterator_current (itr, (void **)&name);
      if (mh_alias_get_internal (name, orig_itr, &exlist, inclusive) == 0)
	{
	  _insert_list (name_list, name, exlist);
	  list_remove (name_list, name);
	  list_destroy (&exlist);
	}
    }
  iterator_destroy (&itr);
  return 0;
}  

/* Look up the named alias. If found, return the list of recipient
   names associated with it */
static int
mh_alias_get_internal (char *name, iterator_t start, list_t *return_list,
		       int *inclusive) 
{
  iterator_t itr;
  int rc = 1;

  if (!start)
    {
      if (list_get_iterator (alias_list, &itr))
	return 1;
      iterator_first (itr);
    }
  else
    {
      iterator_dup (&itr, start);
      iterator_next (itr);
    }
	
  for (; !iterator_is_done (itr); iterator_next (itr))
    {
      struct mh_alias *alias;
      iterator_current (itr, (void **)&alias);
      if (inclusive)
	*inclusive |= alias->inclusive;
      if (aliascmp (alias->name, name) == 0)
	{
	  *return_list = ali_list_dup (alias->rcpt_list);
	  alias_expand_list (*return_list, itr, inclusive);
	  rc = 0;
	  break;
	}
    }
  
  iterator_destroy (&itr);
  return rc;
}

int
mh_alias_get (char *name, list_t *return_list)
{
  return mh_alias_get_internal (name, NULL, return_list, NULL);
}

int
mh_alias_get_address (char *name, address_t *paddr, int *incl)
{
  iterator_t itr;
  list_t list;
  const char *domain = NULL;
  
  if (mh_alias_get_internal (name, NULL, &list, incl))
    return 1;
  if (list_is_empty (list))
    {
      list_destroy (&list);
      return 1;
    }
  
  if (list_get_iterator (list, &itr) == 0)
    {
      for (iterator_first (itr); !iterator_is_done (itr); iterator_next (itr))
	{
	  char *item;
	  address_t a;
	  char *ptr = NULL; 

	  iterator_current (itr, (void **)&item);
	  if (incl && *incl)
	    {
	      if (strchr (item, '@') == 0)
		{
		  if (!domain)
		    mu_get_user_email_domain (&domain);
		  asprintf (&ptr, "\"%s\" <%s@%s>", name, item, domain);
		}
	      else
		asprintf (&ptr, "\"%s\" <%s>", name, item);
	      item = ptr;
	    }
	  if (address_create (&a, item))
	    {
	      mh_error (_("Error expanding aliases -- invalid address `%s'"),
			item);
	    }
	  else
	    {
	      address_union (paddr, a);
	      address_destroy (&a);
	    }
	  if (ptr)
	    free (ptr);
	}
      iterator_destroy (&itr);
    }
  list_destroy (&list);
  return 0;
}

/* Look up the given user name in the aliases. Return the list of
   alias names this user is member of */
int
mh_alias_get_alias (char *uname, list_t *return_list)
{
  iterator_t itr;
  int rc = 1;
  
  if (list_get_iterator (alias_list, &itr))
    return 1;
  for (iterator_first (itr); !iterator_is_done (itr); iterator_next (itr))
    {
      struct mh_alias *alias;
      iterator_current (itr, (void **)&alias);
      if (ali_member (alias->rcpt_list, uname))
	{
	  if (*return_list == NULL && list_create (return_list))
	    break;
	  list_append (*return_list, alias->name);
	  rc = 0;
	}
    }
  
  iterator_destroy (&itr);
  return rc;
}

void
mh_alias_enumerate (mh_alias_enumerator_t fun, void *data)
{
  iterator_t itr;
  int rc = 0;
  
  if (list_get_iterator (alias_list, &itr))
    return ;
  for (iterator_first (itr);
       rc == 0 && !iterator_is_done (itr);
       iterator_next (itr))
    {
      struct mh_alias *alias;
      list_t tmp;
      
      iterator_current (itr, (void **)&alias);

      tmp = ali_list_dup (alias->rcpt_list);
      alias_expand_list (tmp, itr, NULL);

      rc = fun (alias->name, tmp, data);
      list_destroy (&tmp);
    }
  iterator_destroy (&itr);
}

static list_t
unix_group_to_list (char *name)
{
  struct group *grp = getgrnam (name);
  list_t lst = list_create_or_die ();
  
  if (grp)
    {
      char **p;

      for (p = grp->gr_mem; *p; p++)
	list_append (lst, strdup (*p));
    }      
  
  return lst;
}

static list_t
unix_gid_to_list (char *name)
{
  struct group *grp = getgrnam (name);
  list_t lst = list_create_or_die ();

  if (grp)
    {
      struct passwd *pw;
      setpwent();
      while ((pw = getpwent ()))
	{
	  if (pw->pw_gid == grp->gr_gid)
	    list_append (lst, strdup (pw->pw_name));
	}
      endpwent();
    }
  return lst;
}

static list_t
unix_passwd_to_list ()
{
  list_t lst = list_create_or_die ();
  struct passwd *pw;

  setpwent();
  while ((pw = getpwent ()))
    {
      if (pw->pw_uid > 200)
	list_append (lst, strdup (pw->pw_name));
    }
  endpwent();
  return lst;
}

int
mh_read_aliases ()
{
  char *p, *sp;
  
  p = mh_global_profile_get ("Aliasfile", NULL);
  if (p)
    for (p = strtok_r (p, " \t", &sp); p; p = strtok_r (NULL, " \t", &sp))
      mh_alias_read (p, 1);
  mh_alias_read (DEFAULT_ALIAS_FILE, 0);
  return 0;
}

